
var heightMap;
var width;
var height;
var page = 0;
var density = 4;
var space;

/*
function heightMapGet (page, x, y) {
    var offset = (page * width * height) + y * width + x;
    return _heightMap[offset];
}

function heightMapSet (page, x, y, value) {
    var offset = (page * width * height) + y * width + x;
    _heightMap[offset] = value;
}
*/

function waterFilter (pixels) {
//    webkitPostMessage (pixels.buffer);


    var buf = new ArrayBuffer (width * height);
    buf = new Uint8Array (buf);

/*
    webkitPostMessage (buf.buffer);

    return;
*/

    for (var x = 0; x < width; x++) {
      for (var y = 0; y < height; y++) {
        var n = y - 1 < 0 ? 0 : y - 1;
        var s = y + 1 > height - 1 ? height - 1 : y + 1;
        var e = x + 1 > width - 1 ? width - 1 : x + 1;
        var w = x - 1 < 0 ? 0 : x - 1;
        var value = ((heightMap[page][w][n] + heightMap[page][x][n]
          + heightMap[page][e][n] + heightMap[page][w][y]
          + heightMap[page][e][y] + heightMap[page][w][s]
          + heightMap[page][x][s] + heightMap[page][e][s]) >> 2)
          - heightMap[page ^ 1][x][y];

        heightMap[page ^ 1][x][y] = value - (value >> density);


        if (x < width - 1 && y < height - 1) {
            var deltax = heightMap[page][x][y] - heightMap[page][x + 1][y];
            var deltay = heightMap[page][x][y] - heightMap[page][x][y + 1];
            var offsetx = (deltax >> 3) + x;
            var offsety = (deltay >> 3) + y;

            offsetx = offsetx > width ? width - 1 : offsetx < 0 ? 0 : offsetx;
            offsety = offsety > height ? height - 1 : offsety < 0 ? 0 : offsety;

            var offset = (offsety * width) + offsetx;
            offset = offset < 0 ? 0 : offset > space ? space : offset;
//          int pixel = water.pixels[offset];
            var pixel = pixels[offset];
            buf[y * width + x] = pixel;
        }

      }
    }

    webkitPostMessage (buf.buffer);
}

function processCmd (cmd) {
    if (cmd.type == 0) {
        width = cmd.w;
        height = cmd.h;
        space = cmd.s;
        density = cmd.d;

/*
        var buf = new ArrayBuffer (width * height * 2);
        _heightMap = new Uint8Array (buf);
*/

        heightMap = [new Array (), new Array ()];

        for (var i=0; i<width; i++) {
            heightMap[0][i] = new Array (height);
            heightMap[1][i] = new Array (height);
        }

        postMessage ("size set");
    }
}

onmessage = function (msg) {
    if (msg.data.constructor == ArrayBuffer)
        waterFilter (msg.data);
    else
        processCmd (msg.data);
};
